VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Border"
   ClientHeight    =   1395
   ClientLeft      =   2190
   ClientTop       =   1680
   ClientWidth     =   2310
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1395
   ScaleWidth      =   2310
   ShowInTaskbar   =   0   'False
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      Left            =   540
      Max             =   15
      TabIndex        =   0
      Top             =   600
      Width           =   1275
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Draw Border With WinAPI Example
' By Patrick Gillespie (PAT or JK)
' 8.4.00
' http://www.patorjk.com/

' This example shows you how to use win32 api to draw lines and how
' to draw a border with a certain thickness. Use the scrollbar to
' change the border size.

Option Explicit

Private Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpPoint As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long

Private Const PS_SOLID = 0

Private Declare Function GetCapture Lib "user32" () As Long
Private Declare Function SetCapture Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseCapture Lib "user32" () As Long

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Type POINTAPI
        X As Long
        Y As Long
End Type

' system color stuff
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long

Private Const COLOR_BTNSHADOW = 16
Private Const COLOR_BTNHIGHLIGHT = 20
Private Const COLOR_BTNFACE = 15

Private Sub DrawLine(TheDC As Long, X1 As Long, Y1 As Long, X2 As Long, Y2 As Long, PenColor As Long)
    ' This sub draws a line using api.
    Dim NewPen As Long, OldPen As Long
    ' Create the pen to use
    NewPen = CreatePen(PS_SOLID, 1, PenColor)
    ' Hold onto the old pen because we'll be putting it right back
    OldPen = SelectObject(TheDC, NewPen)
    
    ' Draw Line - Move to the point to start at,
    ' then draw a line from that point to another point.
    Call MoveToEx(TheDC, X1, Y1, 0)
    Call LineTo(TheDC, X2, Y2)
    
    ' Put the old pen back
    Call SelectObject(TheDC, OldPen)
    ' Delete the one we created so we don't waste GDI resources
    DeleteObject NewPen
End Sub

Private Sub DrawBorder(TheDC As Long, X As Long, Y As Long, StartWidth As Long, StartHeight As Long)
    ' Draws IE type pop up border around
    ' a certain area
    Dim LightBorderColor As Long, DarkBorderColor As Long
    ' Get the light border color to use
    LightBorderColor = GetSysColor(COLOR_BTNHIGHLIGHT)
    ' Draw the light border
    Call DrawLine(TheDC, X, Y, X + StartWidth, Y, LightBorderColor)
    Call DrawLine(TheDC, X, Y, X, Y + StartHeight, LightBorderColor)
    ' Get the dark border color to use
    DarkBorderColor = GetSysColor(COLOR_BTNSHADOW)
    ' Draw the dark border
    Call DrawLine(TheDC, X, Y + StartHeight, X + StartWidth, Y + StartHeight, DarkBorderColor)
    Call DrawLine(TheDC, X + StartWidth, Y, X + StartWidth, Y + StartHeight + 1, DarkBorderColor)
End Sub

Private Sub DrawBevel(TheDC As Long, Size As Integer)
    ' This sub draws the border with a certain thickness.
    Dim StartX As Long, StartY As Long
    Dim StartWidth As Long, StartHeight As Long
    Dim i As Integer
    StartX = 0
    StartY = 0
    StartWidth = Me.ScaleWidth + 1
    StartHeight = Me.ScaleHeight + 1
    ' Clear the current border (you could only clear the area you
    ' drew lines on, but I'll just use me.cls for the sake of keeping
    ' things simple).
    Me.Cls
    ' Draw the border
    For i = 1 To Size
        StartX = i - 1
        StartY = i - 1
        StartWidth = StartWidth - 2
        StartHeight = StartHeight - 2
        Call DrawBorder(TheDC, StartX, StartY, StartWidth, StartHeight)
    Next
End Sub

Private Sub Form_Load()
    Me.ScaleMode = 3 ' pixels
End Sub

Private Sub Form_Paint()
    ' Redraw the border when the form is repainted
    Call DrawBevel(Me.hdc, HScroll1.Value)
End Sub

Private Sub HScroll1_Change()
    Call DrawBevel(Me.hdc, HScroll1.Value)
End Sub

Private Sub HScroll1_Scroll()
    Call DrawBevel(Me.hdc, HScroll1.Value)
End Sub
